#ifndef _ARENA_H
#define _ARENA_H

// A simple arena for allocating lots of short strings.

class Arena {
public:
	Arena();
	~Arena();

	char *alloc(size_t bytes);

private:
	static constexpr size_t BLOCK_SIZE = 1048576;

	struct Block {
		char *memory;
		size_t used;
		Block *next;
	};
	Block *first;
};

#endif  // _ARENA_H
