#! /bin/bash

set -e

export SHARDS=40
export PARALLEL_MERGES=40

rm -f pgnnames.txt tmp.mtbl* open.mtbl.new open.mtbl.part???? open.mtbl.part????.new 2>/dev/null

for FILE in "$@"; do
	echo "$FILE" >> pgnnames.txt
done

for X in $( seq 0 39 ); do
	(
		(
			PGNNUM=0
			for FILE in "$@"; do
				START=$( ./find-pgn-split-point.sh "$FILE" $X 40 )
				END=$( ./find-pgn-split-point.sh "$FILE" $(( X + 1 )) 40 )
				~/nmu/pgn-extract/pgn-extract --startpos $START --endpos $END --startfilenum $PGNNUM -e -Wsessebin "$FILE" 2>/dev/null
				PGNNUM=$(( PGNNUM + 1 ))
			done
		) | ./binloader - tmp.mtbl.mapper$X $SHARDS 500000
	) &
done
wait

parallel -i -j ${PARALLEL_MERGES} bash -c 'X={}; set -x; ./binmerger tmp.mtbl.mapper*.part$( printf %04d $X ).subshard* open.mtbl.part$( printf %04d $X ).new' -- $( seq 0 $(( SHARDS - 1 )) )

for X in $( seq 0 $(( SHARDS - 1 )) ); do
	mv open.mtbl.part$( printf %04d $X ).new open.mtbl.part$( printf %04d $X )
done
rm -f tmp.mtbl*
